<template>
  <!-- DELETE-BUTTON -->
  <app-link>
    <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="deleteModalLabel">Are you sure you want to delete this item?</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">No</button>
            <button type="button" v-on:click="deleteDataSet" data-dismiss="modal" class="btn btn-primary">Yes</button>
          </div>
        </div>
      </div>
    </div>
    <button data-toggle="modal" data-target="#deleteModal" class="mt-1 btn btn-sm btn-danger">
      {{ $t('message.datasetDetails.delete') }}
    </button>
  </app-link>
</template>

<script>
  // Import components used in template
  import AppLink from './AppLink';
  import { normalize } from '../utils/helpers';
  /* eslint-disable */
  export default {
    name: 'EDP2-datasetDetailsDeleteButton',
    dependencies: ['uploadService'],
    components: {
      appLink: AppLink,
    },
    data() {
      return {};
    },
    props: {
      id: {
        required: true,
      },
      catalogID: {
        required: true,
      },
    },
    methods: {
      /* eslint-disable */
      deleteDataSet() {
        // normalizing dataset ID (as per torben jastrow 17/07/2019)
        let datasetId = this.normalize(this.id);
        // delete dataset API call
        this.$Progress.start();
        this.$keycloak.getRtpToken().then((rtpToken) => {
          this.uploadService.deleteDistribution(datasetId, this.catalogID, rtpToken.data.access_token).then((res) => {
            // Redirect to catalog page
            this.$router.push({ name: 'Datasets', query: { catalog: this.catalogID, showcataloguedetails: 'true', locale: this.$route.query.locale }}).then(() => {
              this.$Progress.finish();
              // Reload page
              window.location.reload();
            });
          }).catch((err) => {
            console.log(err);
            this.$Progress.fail();
          });
        });
      },
      normalize,
    },
  };
</script>

<style lang="scss" scoped>
button {
  margin: 0 5px;
}
</style>
